#[derive(
    Debug,
    Clone,
    conjure_object::serde::Serialize,
    conjure_object::serde::Deserialize,
    conjure_object::private::DeriveWith
)]
#[serde(crate = "conjure_object::serde")]
#[derive_with(PartialEq, Eq, PartialOrd, Ord, Hash)]
#[conjure_object::private::staged_builder::staged_builder]
#[builder(crate = conjure_object::private::staged_builder, update, inline)]
pub struct Completed {
    #[builder(custom(type = super::JobResult, convert = Box::new))]
    #[serde(rename = "result")]
    result: Box<super::JobResult>,
    #[serde(rename = "executionStartTime")]
    execution_start_time: conjure_object::DateTime<conjure_object::Utc>,
    #[serde(rename = "executionEndTime")]
    execution_end_time: conjure_object::DateTime<conjure_object::Utc>,
}
impl Completed {
    /// Constructs a new instance of the type.
    #[inline]
    pub fn new(
        result: super::JobResult,
        execution_start_time: conjure_object::DateTime<conjure_object::Utc>,
        execution_end_time: conjure_object::DateTime<conjure_object::Utc>,
    ) -> Self {
        Self::builder()
            .result(result)
            .execution_start_time(execution_start_time)
            .execution_end_time(execution_end_time)
            .build()
    }
    #[inline]
    pub fn result(&self) -> &super::JobResult {
        &*self.result
    }
    #[inline]
    pub fn execution_start_time(&self) -> conjure_object::DateTime<conjure_object::Utc> {
        self.execution_start_time
    }
    #[inline]
    pub fn execution_end_time(&self) -> conjure_object::DateTime<conjure_object::Utc> {
        self.execution_end_time
    }
}
